/*
 * inputvideo0.h: /dev/video0 input for the Atmolight-plugin
 *
 * See the README file for copyright information and how to reach the author.
 *
 * $Id$
 */

#ifndef _ATMO_INPUTVIDEO0_H
#define _ATMO_INPUTVIDEO0_H

#include <linux/videodev.h>
#include <vdr/thread.h>

// --- cInputVideo0 -----------------------------------------------------------
class cInputVideo0 : public cAtmoInput {
private:
  struct video_mmap v_map;
  struct video_mbuf m_buf;
  void *map;
  int fd, nextframe, actframe;

  void* Capture(void);
  void CalcColors(void);
  tColorPacket CalcColorsAnalyzeHSV(tRGBColor*& RGB_Img, tHSVColor*& HSV_Img);
  tHSVColor RGB2HSV(tRGBColor color);
  tRGBColor HSV2RGB(tHSVColor color);
protected:
  virtual void Action(void);
public:
  cInputVideo0();
  ~cInputVideo0();
  virtual bool Open(const char* param);
  virtual bool Close(void);
};

#endif //_ATMO_INPUTVIDEO0_H
