/*
 * thread.h: The thread for the Atmolight-plugin
 *
 * See the README file for copyright information and how to reach the author.
 *
 * $Id$
 */

#ifndef _ATMO_THREAD__H
#define _ATMO_THREAD__H

// --- cAtmoThread ------------------------------------------------------------

class cAtmoThread : public cThread {
private:
  tColorPacketInt ColorPacketInt;
  cAtmoInput  *Input;  // input device
  cAtmoFilter *Filter; // filter
  cAtmoOutput *Output; // output device

  tColorPacketInt ApplyGamma(tColorPacketInt ColorPacketInt);
  tColorPacketInt WhiteCalibration(tColorPacketInt ColorPacketInt);
  void OutputColors(const tColorPacketInt ColorPacketInt); // write filter output to device
protected:
  virtual void Action(void);
public:
  cAtmoThread();
  ~cAtmoThread();
  void SwitchOn(void);
  void SwitchOff(void);
};

extern cAtmoThread *AtmoThread;

#endif // _ATMO_THREAD__H
